SystemOrganization addCategory: #'Tp3-METAPROGRAMACION'!
SystemOrganization addCategory: 'Tp3-METAPROGRAMACION-TEST'!

Trait named: #GenericEquals
	uses: {}
	category: 'Tp3-METAPROGRAMACION'!

!GenericEquals methodsFor: 'as yet unclassified' stamp: 'marcos 5/6/2014 17:32'!
= unObjeto
	"Toma la lista de variables de #keyProperties determina si el objeto receptor es igual al recibido por parámetro"

	^ self class = unObjeto class and: 
		[ self keyProperties allSatisfy: 
			[:varName | (self instVarNamed: varName) = (unObjeto instVarNamed: varName)]
		]! !

!GenericEquals methodsFor: 'as yet unclassified' stamp: 'Marcos 5/6/2014 20:17'!
keyProperties
	"Espera que le entregen una lista de Strings, que representan un conjunto de nombres de variables de instancia"
	^self requirement.! !

Trait named: #GenericPrint
	uses: {}
	category: 'Tp3-METAPROGRAMACION'!

!GenericPrint methodsFor: 'as yet unclassified' stamp: 'Marcos 5/7/2014 05:45'!
keyProperties
	"Espera que le entregen una lista de Strings, que representan un conjunto de nombres de variables de instancia"
	^self requirement.! !

!GenericPrint methodsFor: 'as yet unclassified' stamp: 'Marcos 5/8/2014 18:10'!
printOn
	"comment stating purpose of message"
	| cadena|
	
	cadena:= (self class) printString, ' ('.
	self keyProperties do: 	[:varName | cadena := cadena, varName, ' = ', (self instVarNamed: varName) printString, ', '].
	
	
	^ cadena, ')'.
	
"	aStream << self class name;
	<< #posicion;
	<< $=;
	print: self posicion.
	
	^ aStream."
	! !

Object subclass: #ObjetoDePrueba
	instanceVariableNames: 'edad nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!ObjetoDePrueba methodsFor: 'as yet unclassified' stamp: 'Marcos 5/8/2014 23:59'!
nombre 
	^ nombre! !

!ObjetoDePrueba methodsFor: 'as yet unclassified' stamp: 'Marcos 5/8/2014 23:59'!
nombre: valor
	nombre:= valor! !

Object subclass: #RenameProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION'!

!RenameProperty methodsFor: 'as yet unclassified' stamp: 'Marcos 5/8/2014 02:13'!
renameProperty: nombre to: nuevoNombre from: objeto

	(objeto class) addInstVarNamed: nuevoNombre.
	
	(objeto class) removeSelector:  nombre asSymbol;  compile: nuevoNombre , ' 
	^ ', nuevoNombre.
	
	(objeto class) removeSelector: (nombre, ':') asSymbol; compile: nuevoNombre , ': valor
	', nuevoNombre, ':= valor'.

	(objeto) instVarNamed: nuevoNombre put: (objeto instVarNamed: nombre).

	(objeto class) removeInstVarNamed: nombre.! !

TestCase subclass: #GenericEqualsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!GenericEqualsTest methodsFor: 'running' stamp: 'Marcos 5/7/2014 05:02'!
setUp
	"|  keyPropertiesCode newClass |
	newClass := Soldado
		subclass: #SoldadoWithGenericEquals 
		uses: GenericEquals
		instanceVariableNames: 'keyProperties'
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	
	
	keyPropertiesCode := 'keyProperties
	^ #(puntosDeVida)'.
	
	newClass compile: keyPropertiesCode classified: 'keyProperties'."
	
		Soldado  addToComposition: GenericEquals.! !

!GenericEqualsTest methodsFor: 'running' stamp: 'Marcos 5/7/2014 04:57'!
tearDown
	"(Smalltalk at: #SoldadoWithGenericEquals) removeFromSystem."
	Soldado removeSelector: #keyProperties.
	Soldado removeFromComposition: GenericEquals.! !

!GenericEqualsTest methodsFor: 'tests' stamp: 'Marcos 5/7/2014 05:04'!
testCase
	| a b |

	a := Soldado enPosicion: 100 @ 100.
	b := Soldado enPosicion: 200 @ 200.

	Soldado compile: 'keyProperties
	^ #(puntosDeVida)'.
	
	self assert: a = b.
	
	Soldado compile: 'keyProperties
	^ #(posicion puntosDeVida)'.
	
	self deny:  a = b. ! !

TestCase subclass: #GenericPrintTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!GenericPrintTest methodsFor: 'running' stamp: 'Marcos 5/7/2014 07:07'!
setUp
	Soldado  addToComposition: GenericPrint.

	Soldado compile: 'keyProperties
	^ #(posicion puntosDeVida)'.! !

!GenericPrintTest methodsFor: 'running' stamp: 'Marcos 5/7/2014 06:25'!
tearDown
	"(Smalltalk at: #SoldadoWithGenericEquals) removeFromSystem."
	Soldado removeSelector: #keyProperties.
	Soldado removeFromComposition: GenericPrint .! !

!GenericPrintTest methodsFor: 'tests' stamp: 'Marcos 5/7/2014 10:20'!
testCase
	| a  |

	a := Soldado enPosicion: 100 @ 100.
	
	self assert: ( a printOn ) = 'Soldado (posicion = (100@100), puntosDeVida = 100, )'.! !

TestCase subclass: #RenamePropertyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp3-METAPROGRAMACION-TEST'!

!RenamePropertyTest methodsFor: 'tests' stamp: 'Marcos 5/8/2014 01:57'!
testCaseGetter

"	self assert: (ObjetoDePrueba canUnderstand: 'nombre' asSymbol).
	
	(RenameProperty new) renameProperty: 'nombre' to: 'unNombre' fromClass: ObjetoDePrueba.

	self assert: (ObjetoDePrueba canUnderstand: 'unNombre' asSymbol).
	self deny: (ObjetoDePrueba canUnderstand: 'nombre' asSymbol).
	
	(RenameProperty new) renameProperty: 'unNombre' to: 'nombre' fromClass: ObjetoDePrueba."! !

!RenamePropertyTest methodsFor: 'tests' stamp: 'Marcos 5/8/2014 01:57'!
testCaseSetter

"	self assert: (ObjetoDePrueba canUnderstand: 'nombre:' asSymbol).
	
	(RenameProperty new) renameProperty: 'nombre' to: 'unNombre' fromClass: ObjetoDePrueba.

	self assert: (ObjetoDePrueba canUnderstand: 'unNombre:' asSymbol).
	self deny: (ObjetoDePrueba canUnderstand: 'nombre:' asSymbol).
	
	(RenameProperty new) renameProperty: 'unNombre' to: 'nombre' fromClass: ObjetoDePrueba."! !

!RenamePropertyTest methodsFor: 'tests' stamp: 'Marcos 5/8/2014 02:08'!
testCaseValues
	
	| luis |
	luis := ObjetoDePrueba new.
	luis nombre: 'Luis'.

	(RenameProperty new) renameProperty: 'nombre' to: 'unNombre' from: luis.

	self assert: (luis unNombre) = 'Luis'.

	(RenameProperty new) renameProperty: 'unNombre' to: 'nombre' from: luis.! !
